############################################################################
#    Copyright (C) 2009 by Kushal Das                                      #
#    kushaldas@gmail.com                                                   #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################


import sys
import os
import PyQt4
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import QByteArray, QBuffer
from optparse import OptionParser

from django.core.management import setup_environ
import settings

setup_environ(settings)

from SonaDatabase.models import *
from SonaFilesystem.filesystem import *


from ukhraui import UkhraApp
from gviewui import gViewApp


def gatherInfo():
    """To find file informations from disk"""
    #path = raw_input("Enter path to the disk: ")
    #disk_name = raw_input("Enter Disk Name: ")
    #disk_tags = raw_input("Enter the tags for the disk (separated by comma): ")
    path = '/junk/pics/pune-marathon-2'
    disk_name = 'Pune Marathon'
    disk_tags = 'marathon, pune'

    allfiles = walk(path)

    d = Disk()
    d.name = disk_name
    d.save()

    for tag in disk_tags.split(','):
        t = Tags()
        t.disk_id = d
        t.tag_name = tag
        t.save()

    for disk_file in allfiles:
        if disk_file.endswith(".jpg") or disk_file.endswith(".nef"):
            exifdata = exif_data(disk_file)

            imagefile = Files()
            imagefile.disk_id = d
            imagefile.file_name = os.path.basename(disk_file)
            imagefile.file_path = os.path.dirname(disk_file)
            imagefile.save()


            exif = ExifData()
            for key in exifdata.keys():
                if key == 'Exif.Image.Make':
                    exif.make = exifdata[key]
                elif key == 'Exif.Image.Model':
                    exif.model = exifdata[key]
                elif key == 'Exif.Image.Orientation':
                    exif.orientation = exifdata[key]
                elif key == 'Exif.Photo.ExposureTime':
                    exif.exposure = exifdata[key]
                elif key == 'Exif.Photo.FNumber':
                    exif.fnumber = exifdata[key]
                elif key == 'Exif.Photo.ISOSpeedRatings':
                    exif.iso = exifdata[key]
                elif key == 'Exif.Photo.ExifVersion':
                    exif.exifVersion = exifdata[key]
                elif key == 'Exif.Photo.DateTimeOriginal':
                    exif.datetimeoriginal = exifdata[key]
                elif key == 'Exif.Photo.MeteringMode':
                    exif.meteringmode = exifdata[key]
                elif key == 'Exif.Photo.Flash':
                    exif.flash = exifdata[key]
                elif key == 'Exif.Photo.FocalLength':
                    exif.focallength = exifdata[key]
                elif key == 'Exif.Photo.UserComment':
                    exif.comment = exifdata[key]
                elif key == 'thumbnail':
                    data = exifdata[key]
                    if data:
                        bytearray = QByteArray(data)
                        exif.thumbnail = bytearray.toBase64().data()
                    elif disk_file.endswith(".jpg"):
                        bytearray = QByteArray()
                        qb = QBuffer(bytearray)
                        qb.open(PyQt4.QtCore.QIODevice.WriteOnly)
                        img = QtGui.QImage(disk_file)
                        #i = img.scaled(800, 600).scaled(160, 120, \
                        i = img.scaled(160, 120, \
                            QtCore.Qt.KeepAspectRatio, \
                            QtCore.Qt.SmoothTransformation)
                        i.save(qb,"JPEG")
                        exif.thumbnail = bytearray.toBase64().data()


            exif.file = imagefile
            #try:
            exif.save()
            #except:
            #    print type(exif.thumbnail)

def search(argv=None):
    u = UkhraApp(argv)

def main(argv):
    """The main function"""
    version = "0.1"
    parser = OptionParser(usage="Check the website", version=version)
    parser.add_option("-a", "--add", action="store_true",
                           help="Add a new disk to the db")
    parser.add_option("-s", "--search", action="store_true",
                           help="To search photos")

    (options, args) = parser.parse_args(args=argv)

    if options.add:
        gatherInfo()
    elif options.search:
        search()
    else:
        #Show the GUI
        g = gViewApp()



if __name__ == '__main__':
    main(sys.argv)
